//
//  ViewController.m
//  mudutv_ios_player
//
//  Created by 郑中杰 on 2017/6/1.
//  Copyright © 2017年 MuduTV. All rights reserved.
//

//#import <AliyunPlayerSDK/AliyunPlayerSDK.h>
#import <MuduComment/MuduComment.h>
#import "ViewController.h"
#import <IJKMediaFrameworkWithSSL/IJKFFMoviePlayerController.h>

@interface ViewController () <UITableViewDataSource>
{
    IJKFFMoviePlayerController* _player;
    UIButton* _exitBtn;
    UIButton* _recordBtn;
    UIButton* _recodeBtn;
    UIButton* _playVideoBtn;
    UILabel* _startL;
    
    NSInteger _tag;
}
//@property (nonatomic, strong) AliVcMediaPlayer* mPlayer;
@property (nonatomic, assign) BOOL mPaused;
@property (nonatomic, copy) NSString *mSourceURL;
@property (nonatomic, strong) UIView *mPlayerView;

@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) NSMutableArray *messageArray;
@property (nonatomic, strong) UITextField *messageField;
@property (nonatomic, strong) UIButton *sendButton;
@property (nonatomic, strong) MDCommenter *commenter;
@property (nonatomic, strong) UIButton *pauseButton;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // 阻止锁屏
    [self.view setBackgroundColor:[UIColor blackColor]];

    [[UIApplication sharedApplication] setIdleTimerDisabled: YES];
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(becomeActive)
                                                 name:UIApplicationDidBecomeActiveNotification
                                               object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(resignActive)
                                                 name:UIApplicationWillResignActiveNotification
                                               object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillChangeFrame:) name:UIKeyboardWillChangeFrameNotification object:nil];
    
    
    CGRect rect = self.view.bounds;
    self.tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 300, rect.size.width, rect.size.height-350) style:UITableViewStylePlain];
    self.tableView.dataSource = self;
    [self.view addSubview:self.tableView];
    self.messageField = [[UITextField alloc] initWithFrame:CGRectMake(0, rect.size.height-50, rect.size.width-80, 50)];
    [self.messageField setBackgroundColor:[UIColor grayColor]];
    [self.view addSubview:self.messageField];
    self.sendButton = [[UIButton alloc] initWithFrame:CGRectMake(rect.size.width-80, rect.size.height-50, 80, 50)];
    [self.sendButton addTarget:self action:@selector(sendButtonClick) forControlEvents:UIControlEventTouchUpInside];
    [self.sendButton setTitle:@"发送" forState:UIControlStateNormal];
    [self.sendButton setBackgroundColor:[UIColor blueColor]];
    [self.view addSubview:self.sendButton];
    
    self.pauseButton = [[UIButton alloc] initWithFrame:CGRectMake(0, 270, 60, 30)];
    [self.pauseButton setTitle:@"暂停" forState:UIControlStateNormal];
    [self.pauseButton addTarget:self action:@selector(pauseButtonClick) forControlEvents:UIControlEventTouchUpInside];
    [self.pauseButton setBackgroundColor:[UIColor blueColor]];
    [self.view addSubview:self.pauseButton];
    
    self.messageArray = [[NSMutableArray alloc] init];

    // 频道推流地址
    self.mSourceURL =@"https://livesec.mudu.tv/watch/4c0v1b.flv?auth_key=1596517313-384815-0-c4ddb1239ef9ffc4a27d6a626d369650";
//        self.mSourceURL =@"http://mudu.tv/watch/6848930";
     [[MDCommenter instance] initWithChannelId:410239 actId:@"o02kzk3m"];
      [[MDCommenter instance] login:@"IOSpublisher2" avatar:@"http://mudu.tv/assets/img/activity/pc/logo.png" callback:^(NSString *data, NSError *err) {
          if (err == nil) {
              NSLog(@"%@",self.commenter.userInfo);
          }
      }];
      [[MDCommenter instance] subscribe];
      
//           [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(SRWebSocketDidOpen) name:kWebSocketDidOpenNote object:nil];
           [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(SRWebSocketDidClose:) name:kWebSocketDidCloseNote object:nil];
        [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(SRWebSocketDidReceiveMsg:) name:kWebSocketdidReceiveMessageNote object:nil];
}
- (void)SRWebSocketDidClose:(NSNotification *)note {
     //收到服务端发送过来的消息
     NSString * message = note.object;
     NSLog(@"111%@",message);
 }
- (void)SRWebSocketDidReceiveMsg:(NSNotification *)note {
    //收到服务端发送过来的消息
    NSString * message = note.object;
    NSLog(@"111%@",message);
    __weak __typeof__(self) weakself = self;
   
    if ([message length]>0) {
//               NSArray *array1 = [string1 componentsSeparatedByString:@"{\"type"];
//               if (array1.count>1) {
//                   NSString *string2 =[NSString stringWithFormat:@"{\"type%@", array1[1]];
       NSData * jsonData = [message dataUsingEncoding:NSUTF8StringEncoding];
          NSError *error;
          id obj = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&error];
          if (error == nil) {
              if ([obj isKindOfClass:[NSDictionary class]]) {
                  // 公网数据格式
                  NSString *dst = [obj objectForKey:@"type"];
                  if([dst isEqualToString:@"comment"]){
                  NSDictionary *dic = [obj objectForKey:@"data"];
                  NSString *chatUser = [dic objectForKey:@"username"];
                  NSString *chatMessage = [dic objectForKey:@"message"];
                  NSString *avatar = [dic objectForKey:@"avatar"];
                      NSString *tim = [self getTimestamp:[dic objectForKey:@"dateline"]];
//                      NSInteger time = [self timeSwitchTimestamp:tim];
                  NSInteger ichecked = [[dic objectForKey:@"checked"] integerValue];
                  NSInteger itop = [[dic objectForKey:@"top"] integerValue];
                  BOOL checked = ichecked == 1;
                  BOOL top = itop == 1;

                  NSString *emojiRegularExpression = @"<img.*?>";
                  NSRegularExpression *emojiRegular = [[NSRegularExpression alloc] initWithPattern:emojiRegularExpression options:NSRegularExpressionDotMatchesLineSeparators error:nil];
                  NSString * message = [emojiRegular stringByReplacingMatchesInString:chatMessage options:NSMatchingWithTransparentBounds range:NSMakeRange(0, chatMessage.length)  withTemplate:@""];

                  [self.messageArray addObject:message];
                [self.tableView reloadData];
                       [self.tableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:self.messageArray.count-1 inSection:0] atScrollPosition:UITableViewScrollPositionBottom animated:YES];
//                                  [weakself.delegate receiveMessage:msgObj type: ];
            
            }
        }
    }
  }
}
- (NSString *)getTimestamp:(NSString*)mStr{
    
    NSString *str3 = [mStr substringToIndex:mStr.length-6];
    NSString *str = [str3 stringByReplacingOccurrencesOfString:@"T"withString:@" "];
    
    return str;
    
}
- (NSInteger)timeSwitchTimestamp:(NSString *)formatTime{
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    
    [formatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"]; //(@"YYYY-MM-dd hh:mm:ss")
    
    NSDate* date = [formatter dateFromString:formatTime]; //------------将字符串按formatter转成nsdate
    
    //时间转时间戳的方法:
    NSInteger timeSp = [[NSNumber numberWithDouble:[date timeIntervalSince1970]*1000] integerValue];
    
    NSLog(@"将某个时间转化成 时间戳timeSp:%ld",(long)timeSp); //时间戳的值
    
    return timeSp;
    
}

- (void)keyboardWillChangeFrame:(NSNotification *)noti
{
    CGFloat duration = [noti.userInfo[@"UIKeyboardAnimationDurationUserInfoKey"] floatValue];
    CGRect frame = [noti.userInfo[@"UIKeyboardFrameEndUserInfoKey"] CGRectValue];
    CGFloat offsetY = frame.origin.y - self.view.frame.size.height;
    
    [UIView animateWithDuration:duration animations:^{
        self.view.transform = CGAffineTransformMakeTranslation(0, offsetY);
    }];
}

- (void)sendButtonClick {
    NSString *message = self.messageField.text;
    NSLog(@"duration =％ld",_player.duration); //获取播放的总时长

    [[MDCommenter instance] publishMessage:message callback:^(NSString *data, NSError *err) {
        if(err == nil) {
            NSLog(@"发送成功");
        } else {
            //发送失败
            NSLog(@"%@", data);
        }
    }];
    [self.messageField setText:@""];
    [self.messageField resignFirstResponder];
}

- (void)pauseButtonClick {
    if (self.mPaused) {
        self.mPaused = NO;
        [_player play];
        [self.pauseButton setTitle:@"暂停" forState:UIControlStateNormal];
    } else {
        self.mPaused = YES;
        [_player pause];
        [self.pauseButton setTitle:@"开始" forState:UIControlStateNormal];
    }
}

- (void) PlayMoive {
    if(self.mSourceURL == nil)
        return;
    
    //new the player
//    self.mPlayer = [[AliVcMediaPlayer alloc] init];
    if (_player) return;
       _player = [[IJKFFMoviePlayerController alloc]initWithContentURLString:self.mSourceURL withOptions:nil];
    CGRect rect = self.view.bounds;
    _player.view.frame = CGRectMake(0, 0, rect.size.width, 300);
    _player.view.tag = _tag;
       [self.view insertSubview:_player.view atIndex:0];
       _tag++;
     [_player setPlayerOptionIntValue:3000 forKey:@"max_cached_duration"];

     [_player setShouldShowHudView:NO];
     [_player prepareToPlay];
//    [self.view addSubview:self.mPlayerView];
    
    //create player, and  set the show view
//    [self.mPlayer create:self.mPlayerView];
    
//    self.mPlayer.mediaType = MediaType_AUTO;
//    // 网络超时时间
//    self.mPlayer.timeout = 25000;
//    // 
//    self.mPlayer.dropBufferDuration = 8000;
//
//    self.mPlayer.scalingMode = scalingModeAspectFit;
//    
//    
//    //传入播放地址，准备播放
//    [self.mPlayer prepareToPlay:[NSURL URLWithString:self.mSourceURL]];
//    //开始播放
//    [self.mPlayer play];
    
    NSLog(@"duration =％ld",_player.duration); //获取播放的总时长
}

-(void)viewDidAppear:(BOOL)animated{
    [super viewDidAppear:animated];
    [self PlayMoive];
}
//recieve prepared notification
- (void)OnVideoPrepared:(NSNotification *)notification {

}

//recieve error notification
- (void)OnVideoError:(NSNotification *)notification {
    
    NSDictionary* userInfo = [notification userInfo];
    NSString* errorMsg = [userInfo objectForKey:@"errorMsg"];
    NSNumber* errorCodeNumber = [userInfo objectForKey:@"error"];
    NSLog(@"%@-%@",errorMsg,errorCodeNumber);
}



- (void)becomeActive{
    [self EnterForeGroundPlayVideo];
}

- (void)resignActive{
    [self EnterBackGroundPauseVideo];
}

-(void) EnterBackGroundPauseVideo
{
//    if(self.mPlayer && self.mPaused == NO) {
//        [self.mPlayer pause];
//    }
}

-(void) EnterForeGroundPlayVideo
{
//    if(self.mPlayer && self.mPaused == NO) {
//        [self.mPlayer play];
//    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) dealloc
{
    [self.commenter unsubscribe];
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

#pragma tableview delegate

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [self.messageArray count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    NSString * cellID = @"message";
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:cellID];
    if (cell == nil) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellID];
    }
    cell.textLabel.text = [self.messageArray objectAtIndex:(long)indexPath.row];

    return cell;
}

@end
