//
//  MDCommenter.h
//  MuduComment
//
//  Created by 郑中杰 on 2017/7/25.
//  Copyright © 2017年 MuduTV. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "SocketRocket.h"
typedef void (^PubilshReply) (NSString* data, NSError *err);
extern NSString * const kNeedPayOrderNote;
extern NSString * const kWebSocketDidOpenNote;
extern NSString * const kWebSocketDidCloseNote;
extern NSString * const kWebSocketdidReceiveMessageNote;

@protocol WebSocketManagerDelegate<NSObject>

-(void)webSocketDidReceiveMessage:(NSString *)string;

@end

@interface MDCommenter : NSObject
@property(nonatomic, strong) MDWebSocket *webScoket;
@property(nonatomic, weak) id<WebSocketManagerDelegate> delegate;
@property(nonatomic, assign) BOOL isConnect; //是否连接
@property (nonatomic, copy, readonly) NSDictionary *userInfo;

//获取连接状态
@property (nonatomic,assign,readonly) MDReadyState socketReadyState;

+ (MDCommenter *)instance;
- (void)initWithChannelId:(NSInteger)channelId actId:(NSString*)actId;

- (void)login:(NSString*)user avatar:(NSString*)avatarUrl callback:(PubilshReply)callback;

/** 开始订阅 */
- (void)subscribe;
/** 退出时必须取消订阅，否则下次订阅无法生效*/
- (void)unsubscribe;

/** 发送数据 */
- (void)publishMessage:(NSString*)message callback:(PubilshReply)callback;

/** 重连 */
- (void)reConnect;



@end
